									/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#ifndef _DRVI2C_Flash_H
#define _DRVI2C_Flash_H

#include "M051Series.h"
typedef enum 
{
  E_NO_CHARGER  	= 0,
  E_CHARGING 		= 1,//RED
  E_CHARGED_FULL  	= 2,//GREEN
  E_CHARGING_ERROR  = 255,//RED + GREEN
}E_CHARGING_STATUS;

typedef enum 
{
  E_NO_CHARGER_USB  = 0,
  E_CHARGER 		= 1,
  E_USB  			= 2,
  E_UNKNOWN  		= 255,
}E_USB_STATUS;



void InitI2C_HW(void);
void UpdateChargingStatus(E_CHARGING_STATUS u8Temp);
void UpdateUSBStatus(E_USB_STATUS u8Temp);
void UpdateGauge_Battery_Capacity(uint8_t u8Temp);
void UpdateGauge_Temperature(uint8_t u8Temp);
void UpdateGauge_Battery_Gauge_ID(uint8_t* u8Temp);
void UpdateuP_HW_ID_code(uint8_t* u8Temp);
void Set_PV_flag(void);
void Clr_PV_flag(void);

#endif
