/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "GPIO.h"
#include "DrvSYS.h"
#include "DrvI2C_HW.h"
#define ICE_interfcae 0

/*
Port 0
PMD		0x0000
PIN		0xF8
P0.0	PIN40	Input		H	HS_IN_R					26	 --
P0.1	PIN39	Input		L	AC_USB_IN_R		  		25
P0.2	PIN38	Input		L	15V_IN_R				24
P0.3	PIN37	Input		H	SUS_SW#_R				23	 
P0.4	PIN35	Input		H	VOL_UP#_R			  	21	 
P0.5	PIN34	Input		H	VOL_DOWN#_R			  	20	 
P0.6	PIN33	Input		H	HP_IN#				  	19	 
P0.7	PIN32	Input-ND	H	ALS_INT#				18	




Port 1
PMD		0x4000
PIN 	0xFC
P1.0	PIN43	Input		H	BAT_GD			ADC0	27	 --		
P1.1	PIN44 	Input-ND	L	PB_DIS_uP		ADC1	28
P1.2	PIN45	Input		H	DOCK_IN#_R		ADC2	29
P1.3	PIN46	Input-ND	H	O_LID#_R		ADC3	30   
P1.4	PIN47	Input		H	LOUT_DET#_R		ADC4 	31   
P1.5	PIN1	Input-ND	H	DOCK_ACOK		ADC5	1	 
P1.6	PIN2	Input-ND	H	AP_WAKE#_R		ADC6   	2	 
P1.7	PIN3	Output		H	EC_Request#		ADC7	3



Port 2
PMD		0x4555
DOUT	0x0E
P2.0	PIN19	Output		L	BAT_L_MOD		PWM0	11		
P2.1	PIN20	Output		H	R_LED# 			PWM1
P2.2	PIN21	Output		H	YG_LED#			PWM2		
P2.3	PIN22	Output		H	uP_PWR_EN		PWM3	12
P2.4	PIN23	Output  	L	HUB_SLEEP#		PWM4	13	------------
P2.5	PIN25	Output  	L	GPS_LNA_EN		PWM5	15	------------
P2.6	PIN26	Input-ND	L	CAP_PROX_INT	PWM6	16	------------default disable interrupt
P2.7	PIN27	Output		L	uP_VIB_EN		PWM7	17


Port 3
PMD		0x5A55
DOUT	0x30
P3.0	PIN5	Output	L	HS_5V_EN		Rx		4	
P3.1	PIN7	Output	L	DIS_CHG			Tx	 	5
P3.2	PIN8	Output	L	FM34_RST#		INT0	6
P3.3	PIN9 	Output	L	FM34_PDN#		INT1 	7
P3.4	PIN10	I2C			SDA	 			SDA
P3.5	PIN11	I2C			SCL		   		SCL
P3.6	PIN13 	Output	L	uP_SPK_EN			   	9
P3.7	PIN14 	Output	L	EN_3V3_1V2			   	10




Port 4
PMD		0x9A55
DOUT	0xF8
P4.0	PIN24 	Output	L	uP_CAM_PWR_EN			14	
P4.1	PIN36 	Output	L	uP_HP_MIC_SEL		 	22
P4.2	PIN48 	Output	L	uP_SYS_FET			   	32	------------
P4.3	PIN12 	Output	H	uP_BAT_FET				8	------------	
P4.4	PIN28	SW_I2C		SDA
P4.5	PIN29	SW_I2C		SCL	
P4.6	PIN30	Output	H	ICE_CLK/TS_RST#   		11	------------	
P4.7	PIN31	OpenDrain	H	ICE_DAT/SYS_INT#  		10 //A60-> 1.8V , P02->3.3v
*/


SystemFlag_T SystemFlag; 
uint8_t u8PNewPIN[2];
uint8_t u8POldPIN[2]={0xF8,0xFC};
uint8_t u8PWaitStatus[2] = {0,0};
uint8_t u8PProcStatus[2] = {0xFF,0x7F};
//----------------------------------------------------------------------------TMR2_IRQHandler
void TMR2_IRQHandler(void)
{ 
#ifdef WakeUpFlow
 	WakeUpFlow;
#endif
 	TIMER2->TISR.TIF = 1;

	u8PNewPIN[0] = PORT0->PIN;
	u8PNewPIN[1] = PORT1->PIN;

	u8POldPIN[0] = (u8POldPIN[0]&~u8PProcStatus[0])|(u8PNewPIN[0]&u8PProcStatus[0]);  
	u8POldPIN[1] = (u8POldPIN[1]&~u8PProcStatus[1])|(u8PNewPIN[1]&u8PProcStatus[1]);

	__disable_irq();
	if(u8PWaitStatus[0]|u8PWaitStatus[1])
	{
		u8PProcStatus[0] = u8PWaitStatus[0];
		u8PProcStatus[1] = u8PWaitStatus[1];
		u8PWaitStatus[0] = 0;
		u8PWaitStatus[1] = 0;
		TIMER2->TCSR.CEN=1;		
	}else
	{
		u8PProcStatus[0] = 0;
		u8PProcStatus[1] = 0;
	}
	__enable_irq();
}


//----------------------------------------------------------------------------GPIOP0P1_IRQHandler
void GPIOP0P1_IRQHandler(void)
{
	uint32_t u8PStatus[2];

#ifdef WakeUpFlow
 	WakeUpFlow;
#endif


    /* Keep the interrupt source */
	u8PStatus[0] = PORT0->ISRC;
	u8PStatus[1] = PORT1->ISRC;

	if(u8PProcStatus[0]|u8PProcStatus[1])
	{
	    u8PWaitStatus[0] |= u8PStatus[0];
	    u8PWaitStatus[1] |= u8PStatus[1];
	}else
	{
	    u8PProcStatus[0] = u8PStatus[0];
	    u8PProcStatus[1] = u8PStatus[1];
		TIMER2->TCSR.CEN=1;
	}	

    /* Clear the interrupt */
    PORT0->ISRC = u8PStatus[0];
    PORT1->ISRC = u8PStatus[1]; 	  
}
//----------------------------------------------------------------------------PWM
#if 0 
void InitPWM(void)
{			
	/* Step 2. Enable and Select PWM clock source*/		
	SYSCLK->APBCLK.PWM01_EN = 3;//Enable PWM clock
	SYSCLK->CLKSEL1.PWM01_S = 3;//Select 22.1184Mhz for PWM clock source

	PWMA->PPR.CP01=1;			//Prescaler 0~255, Setting 0 to stop output clock
	PWMA->CSR.CSR0=4;			// PWM clock = clock source/(Prescaler + 1)/divider
								// 22118400/(1+1)/1	= 11059200
				         
	/* Step 3. Select PWM Operation mode */
	//PWM0
	PWMA->PCR.CH0MOD=1;			//0:One-shot mode, 1:Auto-load mode
								//CNR and CMR will be auto-cleared after setting CH0MOD form 0 to 1.
	PWMA->CNR0=0xACCD;			// 11059200/250 = 44237
	PWMA->CMR0=0x1148;

	PWMA->PCR.CH0INV=0;			//Inverter->0:off, 1:on
	PWMA->PCR.CH0EN=1;			//PWM function->0:Disable, 1:Enable
 	PWMA->POE.PWM0=1;			//Output to pin->0:Diasble, 1:Enable

	/* Step 1. GPIO initial */ 
	SYS->P2_MFP.ALT0_AD8_PWM0=1;
}
#else
//----------------------------------------------------------------------------PWM 
void InitPWM(void)
{			
	/* Step 2. Enable and Select PWM clock source*/		
	SYSCLK->APBCLK.PWM01_EN = 3;//Enable PWM clock
	SYSCLK->CLKSEL1.PWM01_S = 3;//Select 22.1184Mhz for PWM clock source

	PWMA->PPR.CP01=176;			//Prescaler 0~255, Setting 0 to stop output clock
	PWMA->CSR.CSR0=4;			// PWM clock = clock source/(Prescaler + 1)/divider
								// 22118400/(176+1)/1	= 124962.71
				         
	/* Step 3. Select PWM Operation mode */
	//PWM0
	PWMA->PCR.CH0MOD=1;			//0:One-shot mode, 1:Auto-load mode
								//CNR and CMR will be auto-cleared after setting CH0MOD form 0 to 1.
	PWMA->CNR0=500;				// 124962.71/250 = 499.85
	PWMA->CMR0=50;

	PWMA->PCR.CH0INV=0;			//Inverter->0:off, 1:on
	PWMA->PCR.CH0EN=1;			//PWM function->0:Disable, 1:Enable
 	PWMA->POE.PWM0=1;			//Output to pin->0:Diasble, 1:Enable

	/* Step 1. GPIO initial */ 
	SYS->P2_MFP.ALT0_AD8_PWM0=1;
}
#endif
//----------------------------------------------------------------------------HW I2C command
void SetPWMRatio(uint8_t u8Temp)
{
	if(u8Temp > 100)
	{
		u8Temp = 100;
	}else if(u8Temp<10)
	{
		u8Temp = 10;
	}
	PWMA->CMR0 = (PWMA->CNR0 * u8Temp)/100;	
	#ifdef DEBUG_ENABLE_SEMIHOST
	//printf("PWM ratio %d%%\n",u8Temp);
	#endif
}
uint8_t GetPWMRatio(void)
{
	uint32_t u32Temp;
	u32Temp = ((PWMA->CMR0 * 100)/ PWMA->CNR0);
	return u32Temp;
}

//------------------------------------------------------------------------UpdateInterruptStatus
void UpdateInterruptStatus(uint8_t* p8Temp)
{
	uint8_t i;
	for(i=0;i<4;i++)
	{
		p8Temp[i] = SystemFlag.u8Flag[i];
		SystemFlag.u8Flag[i]=0;
	}
}
//------------------------------------------------------------------------GPIO Input
#if 0
volatile uint32_t* p32GPIO_I[13] = {&I_DOCK_ACOK,&I_AP_WAKE_R,&I_ALS_INT,&I_HP_IN,&I_VOL_DOWN_R,&I_VOL_UP_R,&I_SUS_SW_R,&I_AC_USB_IN_R,
									&I_PWR_ON_OFF_R,&I_PB_DIS_uP,&I_DOCK_IN_R,&I_O_LID_R,&I_LOUT_DET_R};
#endif

uint8_t	u8GPIO_I[13]= {0x15, 0x16, 0x07, 0x06, 0x05, 0x04, 0x03, 0x01,0x00, 0x11, 0x12, 0x13, 0x14};
void GetGPIO_InputLevel(uint8_t* p8Temp)
{
	uint8_t i;
	p8Temp[0] = 0;
	p8Temp[1] = 0;
	for(i = 0; i<8 ;i++)
	{
		p8Temp[0] |= (((u8POldPIN[u8GPIO_I[i]>>4]) >> (u8GPIO_I[i]&0x0F))&0x01)<<i;
		if(i<5)									 
			p8Temp[1] |= (((u8POldPIN[u8GPIO_I[i+8]>>4]) >> (u8GPIO_I[i+8]&0x0F))&0x01)<<i;
	}

	#ifdef DEBUG_ENABLE_SEMIHOST
	//printf("Input_level:0x%2x%2x\n",p8Temp[1],p8Temp[0]);
	#endif
}

void GetGPIO_InterruptEnable(uint8_t* p8Temp)
{
	uint8_t i,u8Temp[2];
	p8Temp[0] = 0;
	p8Temp[1] = 0;
	u8Temp[0] = PORT0->IEN;
	u8Temp[1] = PORT1->IEN;
	for(i = 0; i<8 ;i++)
	{
		p8Temp[0] |= (((u8Temp[u8GPIO_I[i]>>4]) >> (u8GPIO_I[i]&0x0F))&0x01)<<i;
		if(i<5)									 
			p8Temp[1] |= (((u8Temp[u8GPIO_I[i+8]>>4]) >> (u8GPIO_I[i+8]&0x0F))&0x01)<<i;
	}

	#ifdef DEBUG_ENABLE_SEMIHOST
	printf("Interrupt Mask:0x%2x%2x\n",p8Temp[1],p8Temp[0]);
	#endif

}

void SetGPIO_InterruptEnable(uint8_t* p8Temp)
{
	uint8_t i, u8Temp[2] = {0,0};
	uint32_t u32Temp;
	for(i = 0; i<8 ;i++)
	{
		if((p8Temp[0]>>i)&0x01)
		{
			u8Temp[(u8GPIO_I[i]>>4)] |=  1<< (u8GPIO_I[i]&0x0F);		
		}

		if(((p8Temp[1]>>i)&0x01)&&(i<5))
		{
			u8Temp[(u8GPIO_I[i+8]>>4)] |=  1<< (u8GPIO_I[i+8]&0x0F);		
		}
	}
	u32Temp = u8Temp[0];
	outpw(&PORT0->IEN,(u32Temp | (u32Temp<<16)));

	u32Temp = u8Temp[1];
	outpw(&PORT1->IEN,(u32Temp | (u32Temp<<16)));

	#ifdef DEBUG_ENABLE_SEMIHOST
	printf("Interrupt Mask:0x%2x%2x\n",p8Temp[1],p8Temp[0]);
	#endif
}


//------------------------------------------------------------------------GPIO Input
volatile uint32_t* p32GPIO_O[16] = {&O_EC_Request,&O_uP_TS_RST,&O_DIS_CHG,&O_FM34_RST,&O_FM34_PDN,&O_uP_TS_PWR_EN,&O_uP_SPK_EN,&O_AUD_EN,
									&O_uP_PWR_EN,&O_uP_AC_USB,&O_uP_CAM_PWR_EN,&O_uP_USB_SEL1,&O_uP_USB_SEL2,&O_uP_VIB_EN,&O_uP_HP_MIC_SEL,&O_uP_LCD_ON_OFF};

void GetGPIO_OutputLevel(uint8_t* p8Temp)
{
	uint8_t i;
	p8Temp[0] = 0;
	p8Temp[1] = 1;
	for(i = 0; i<8 ;i++)
	{
		p8Temp[0] |= (*p32GPIO_O[i]) << i;
		p8Temp[1] |= (*p32GPIO_O[i+8]) <<i ;		
	}

	#ifdef DEBUG_ENABLE_SEMIHOST
	printf("Output_level:0x%2x%2x\n",p8Temp[1],p8Temp[0]);
	#endif

}
void SetGPIO_OutputLevel(uint8_t* p8Temp)
{
	uint8_t i;
	for(i = 0; i<8 ;i++)
	{
		*p32GPIO_O[i] =  p8Temp[0] >> i;
		*p32GPIO_O[i+8] =  p8Temp[1] >> i;	
	}
	#ifdef DEBUG_ENABLE_SEMIHOST
	printf("Output_level:0x%2x%2x\n",p8Temp[1],p8Temp[0]);
	#endif
}

//----------------------------------------------------------------------------Init GPIO
void InitGPIO(void)
{

	outpw(&PORT0->PMD,0x0000);		/*Set Input/Output*/
	outpw(&PORT1->PMD,0x4000);
	outpw(&PORT2->PMD,0x4555);
	outpw(&PORT3->PMD,0x5A55);
	outpw(&PORT4->PMD,0x9A55);

	PORT1->DOUT = 0xFD;				/*Set default status for Output*/
	PORT2->DOUT = 0x0E;				/*Set default status for Output*/
	PORT3->DOUT = 0xB0;
	PORT4->DOUT = 0xF8;

	SYS->P0_MFP.SCHMITT=0xFF;
	SYS->P1_MFP.SCHMITT=0x7F;
	SYS->P2_MFP.SCHMITT=0x40;
	SYS->P3_MFP.SCHMITT=0x10;

#if (ICE_interfcae ==0)
	outpw(&SYS->P4_MFP,0);//Set GPIO mode, not ICP mode
	//InitPWM();
#endif
	/*Set Timer2*/
	SYSCLK->CLKSEL1.TMR2_S = 7;//__IRC22M
	*((__IO uint32_t *) &SYSCLK->APBCLK) |= (1<<E_SYS_TMR2_CLK);//Enable Timer2 clock

    *((__IO uint32_t *) &SYS->IPRSTC2) |= (1<<E_SYS_TMR2_RST);//Reset Timer2
    *((__IO uint32_t *) &SYS->IPRSTC2) &= ~(1<<E_SYS_TMR2_RST);

	TIMER2->TCMPR = ((__IRC22M)/50)-1;//Set Compare register
	outpw((uint32_t)&TIMER2->TCSR,0x20000000);//Set Timer2 
	NVIC_SetPriority(TMR2_IRQn, 1);
	NVIC_EnableIRQ(TMR2_IRQn);//Enable NVIC interrupt

	//DrvSYS_Delay(10000);//Delay 10mS
	TMR2_IRQHandler();//Do key function

	/*Clear GPIO interrupt flag*/
	outpw(&PORT0->ISRC,0xFF);
	outpw(&PORT1->ISRC,0x7F);
	/*Enable GPIO interrupt*/
	outpw(&PORT0->IEN,0x00FF00FF);
	outpw(&PORT1->IEN,0x007F007F);
	/*Enable NVIC for Port 0,1*/
    NVIC_SetPriority(GPIO_P0P1_IRQn, 0);
    NVIC_EnableIRQ(GPIO_P0P1_IRQn);
	
}


