/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#ifndef GPIO_H
#define GPIO_H
#include "M051Series.h"
#include "DrvGPIO.h"
typedef struct
{
    union {
        __IO uint8_t u8Flag[4];
        struct {
		    __IO uint32_t 	DOCK_ACOK:1;
		    __IO uint32_t 	DOCK_INT:1;//
		    __IO uint32_t 	ALS_INT:1;//
			__IO uint32_t 	HP_IN:1;
			__IO uint32_t 	VOL_DOWN:1;//
			__IO uint32_t 	VOL_UP:1;//
			__IO uint32_t 	SUS_SW:1;//
		    __IO uint32_t 	AC_USB_Status_Change:1;
			__IO uint32_t 	PWR_EN:1;
			__IO uint32_t 	DOCK_PB:1;
			__IO uint32_t 	DOCK_IN:1;
			__IO uint32_t 	LID_CLOSE:1;
			__IO uint32_t 	AUD_ACC_IN:1;
		    __I  uint32_t  	RESERVE:19;  
        } Flag;
    }; 
}SystemFlag_T;

#define I_PWR_ON_OFF_R 		P00_DOUT//
#define I_AC_USB_IN_R 		P01_DOUT//
#define I_15V_IN_R 			P02_DOUT
#define I_SUS_SW_R 			P03_DOUT//
#define I_VOL_UP_R 			P04_DOUT//
#define I_VOL_DOWN_R 		P05_DOUT//
#define I_HP_IN 			P06_DOUT//
#define I_ALS_INT			P07_DOUT//

#define I_USB_DN_ADC_R 		P10_DOUT
#define I_PB_DIS_uP 		P11_DOUT//
#define I_DOCK_IN_R 		P12_DOUT//
#define I_O_LID_R 			P13_DOUT//
#define I_LOUT_DET_R		P14_DOUT//
#define I_DOCK_ACOK 		P15_DOUT//
#define I_AP_WAKE_R			P16_DOUT//
#define O_EC_Request 		P17_DOUT

#define O_uP_BL_PWM 		P20_DOUT
#define O_YG_LED 			P21_DOUT
#define O_R_LED 			P22_DOUT
#define O_uP_PWR_EN 		P23_DOUT
#define O_uP_AC_USB 		P24_DOUT
#define O_uP_USB_SEL1 		P25_DOUT
#define O_uP_USB_SEL2 		P26_DOUT
#define O_uP_VIB_EN 		P27_DOUT

#define O_uP_TS_RST 		P30_DOUT
#define O_DIS_CHG 			P31_DOUT
#define O_FM34_RST 			P32_DOUT
#define O_FM34_PDN 			P33_DOUT
#define O_uP_SPK_EN 		P36_DOUT
#define O_AUD_EN 			P37_DOUT
#define O_uP_CAM_PWR_EN 	P40_DOUT
#define O_uP_HP_MIC_SEL 	P41_DOUT
#define O_uP_LCD_ON_OFF 	P42_DOUT
#define O_uP_TS_PWR_EN 		P43_DOUT
#define O_SYS_INT 			P47_DOUT

void InitGPIO(void);
void InitPWM(void);
void TurnOff_uP_PWR_EN(uint32_t u32count, uint32_t u32unit);
void SetPWMRatio(uint8_t u8Temp);
uint8_t GetPWMRatio(void);
void SetGPIO_OutputLevel(uint8_t* p8Temp);
void GetGPIO_InputLevel(uint8_t* p8Temp);
void GetGPIO_OutputLevel(uint8_t* p8Temp);
void SetGPIO_InterruptEnable(uint8_t* p8Temp);
void UpdateInterruptStatus(uint8_t* p8Temp);
void UpdateInterruptStatus(uint8_t* p8Temp);
void GetGPIO_InterruptEnable(uint8_t* p8Temp);

#endif


