/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright (c) Nuvoton Technology Corp. All rights reserved.                                             */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#define DelayTime 2// second
#include <stdio.h>
#include "M051Series.h"
#include "DrvSYS.h"
#include "DrvGPIO.h"
#include "EEPROM_24LC64.h"
#include "DrvI2C.h"
void ProgramAPROM(uint32_t address, uint8_t* data);

extern uint32_t loaderImageBase;
extern uint32_t loaderImageLimit;

uint8_t gu8Count = 0, isPress = FALSE;


uint8_t i2cdata[32];

void I2ctest(uint8_t I2command)
{
	Read_24LC64(I2command,i2cdata);
	DrvSYS_Delay(1000);
}

void UpdateAPROM(void)
{
	uint32_t u32ImageSize, i, j;
	uint8_t* pu8Loader;
	uint32_t u32Temp=0;


	I2ctest(0x00);
	u32Temp =  i2cdata[1]<<8 | i2cdata[0];
	printf("uP_HW_ID_code -> 0x%x\n",u32Temp);

	I2ctest(0x01);
	u32Temp =  i2cdata[1]<<8 | i2cdata[0];
	printf("uP_FW_ID_code -> 0x%x\n",u32Temp);

 	I2ctest(0x02);
	printf("\nBoot selection -> %d\n",i2cdata[0]);
    
	printf("Update APROM\n");
    u32ImageSize = (uint32_t)&loaderImageLimit - (uint32_t)&loaderImageBase;
    pu8Loader = (uint8_t *)&loaderImageBase;

    for (i = 0;i < (u32ImageSize - 32);i += 32)
    {
        for (j = 0;j < 32;j ++)
        {
           i2cdata[j] = pu8Loader[i + j];
        }
		ProgramAPROM(0x04,i2cdata);
   }

   for (j = 0;j < 32;j ++)
   {
   		i2cdata[j] = pu8Loader[i + j];
   }
   ProgramAPROM(0x04,i2cdata);
   
   DrvSYS_Delay(10000);
   printf("Update APROM ready\n");

	i2cdata[0] = 0xA5;
	Write_24LC64(0x03,i2cdata);

	DrvSYS_Delay(50000);
 	I2ctest(0x02);	  
	printf("Boot selection -> %d\n",i2cdata[0]);
}

int main(void)
{
	outpw(&PORT1->PMD,0x4003);
	SYS->P1_MFP.SCHMITT=0x7E;
	DrvGPIO_InitFunction(E_FUNC_I2C);

    UpdateAPROM();
	while(1);
}

