/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2010 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "M051Series.h"
#include "DrvGPIO.h"
#include "DrvI2C.h"
#include "DrvSYS.h"
#include "EEPROM_24LC64.h"

void Write_24LC64(uint32_t address, uint8_t* data)
{
    //Open I2C1 and set clock = 50Kbps
    SystemCoreClock = DrvSYS_GetHCLKFreq();
    DrvI2C_Open(400000);
    //send i2c start
    DrvI2C_Ctrl(1, 0, 1, 0);        //set start
    while (I2C->CON.SI == 0);               //poll si flag

    //send write slave address
    I2C->DATA = 0x15 << 1;
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

     //send write command address
    I2C->DATA = address;
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

     //send write data
    I2C->DATA = data[0];
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

     //send write data
    I2C->DATA = data[1];
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

      //send write data
    I2C->DATA = data[2];
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

     //send write data
    I2C->DATA = data[3];
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

     //send write data
    I2C->DATA = data[4];
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag



    //send i2c stop
    DrvI2C_Ctrl(0, 1, 1, 0);    //clr si and set stop
    while (I2C->CON.STO == 1);
    DrvI2C_Close();
}

void Read_24LC64(uint32_t address, uint8_t* data)
{

    //Open I2C1 and set clock = 50Kbps
    SystemCoreClock = DrvSYS_GetHCLKFreq();
    DrvI2C_Open(400000);
    //send i2c start
    DrvI2C_Ctrl(1, 0, 1, 0);        //set start
    while (I2C->CON.SI == 0);               //poll si flag

    //send write slave address
    I2C->DATA = 0x15 << 1;
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

     //send write command address
    I2C->DATA = address;
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

    DrvI2C_Ctrl(1, 0, 1, 0); //send repeat start
    //while (I2C->CON.STO == 1);
    while (I2C->CON.SI == 0);               //poll si flag

    //send read slave address
    I2C->DATA =  (0x15 << 1)+1;
    DrvI2C_Ctrl(0, 0, 1, 1);    //clr si
    while (I2C->CON.SI == 0);               //poll si flag

    //read data
    DrvI2C_Ctrl(0, 0, 1, 1);    //clr si
    while (I2C->CON.SI == 0);               //poll si flag
    data[0] = I2C->DATA;

    //read data
    DrvI2C_Ctrl(0, 0, 1, 1);    //clr si
    while (I2C->CON.SI == 0);               //poll si flag
    data[1] = I2C->DATA;

    //read data
    DrvI2C_Ctrl(0, 0, 1, 1);    //clr si
    while (I2C->CON.SI == 0);               //poll si flag
    data[2] = I2C->DATA;

    //read data
    DrvI2C_Ctrl(0, 0, 1, 1);    //clr si
    while (I2C->CON.SI == 0);               //poll si flag
    data[3] = I2C->DATA;

    //read data
    DrvI2C_Ctrl(0, 0, 1, 0);    //clr si
    while (I2C->CON.SI == 0);               //poll si flag
    data[4] = I2C->DATA;

    //send i2c stop
    DrvI2C_Ctrl(0, 1, 1, 0);    //clr si and set stop
    while (I2C->CON.STO == 1);
    DrvI2C_Close();
}

void ProgramAPROM(uint32_t address, uint8_t* data)
{
	uint32_t i;

    //Open I2C1 and set clock = 50Kbps
    SystemCoreClock = DrvSYS_GetHCLKFreq();
    DrvI2C_Open(400000);
    //send i2c start
    DrvI2C_Ctrl(1, 0, 1, 0);        //set start
    while (I2C->CON.SI == 0);               //poll si flag

    //send write slave address
    I2C->DATA = 0x15 << 1;
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

     //send write command address
    I2C->DATA = address;
    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
    while (I2C->CON.SI == 0);               //poll si flag

	for(i=0;i<32;i++)
	{
	     //send write data
	    I2C->DATA = data[i];
	    DrvI2C_Ctrl(0, 0, 1, 0);       //clr si
	    while (I2C->CON.SI == 0);               //poll si flag
	}

    //send i2c stop
    DrvI2C_Ctrl(0, 1, 1, 0);    //clr si and set stop
    while (I2C->CON.STO == 1);
    DrvI2C_Close();
}
